#!/usr/bin/env sage
# vim: ft=python
#
# Forfatter: John Aslak Wee Kleven
# Lisens: GPL 3.0 (https://www.gnu.org/licenses/gpl-3.0.en.html)

# https://hep.princeton.edu/mumu/target/Yan/ellipse_fit.pdf
pts = [ [-1.68,  1.02], [ 1.39,  1.94], [ 3.20,  0.34], [ 3.41, -1.25], [ 1.89, -2.11], [ 0.21, -2.37], [-1.00, -2.00], [-1.79, -0.57] ] # lagd i geogebra; ellipse
# parabel
#pts = [ [1,1] ,[2,4], [3,9], [0,0], [-1,1], [-2,4], [-3,9], [4, 16], [-4, 16]]
#pts = [ [1,0], [2,1], [3,2], [4,3], [2,-1], [2,-2], [-1,1], [-2,2], [-2,-2]] # omtrent en hyperbel

# Nå for å tilpasse en ellipse til noen punkter
var("x y")

# Kvadratisk form.
# Den kan ende opp med å være "degenerate".
vect = lambda x,y: vector([x^2, x*y, y^2, x, y])

A = Matrix( list( vect(k[0], k[1]) for k in pts))
z = vector(list(1 for k in pts)) # ellipselikningen/kvadratiske former har =1 til slutt

coeffs = N(A).pseudoinverse() * z

print(N(coeffs) * vect(x,y))

f(x,y) = N(coeffs) * vect(x,y) - 1

i = list_plot(pts) + implicit_plot(f(x), (x, -3, 4), (y, -3, 3))
NAME="ellipse.png"
print(f"Plot saved to {NAME}.")
i.save(NAME, dpi=500)
