#!/usr/bin/env sage
# vim: ft=python
#
# Forfatter: John Aslak Wee Kleven
# Lisens: GPL 3.0 (https://www.gnu.org/licenses/gpl-3.0.en.html)


# Et trigonometrisk problem (fra https://textbooks.math.gatech.edu/ila/1553/least-squares.html).
# Finn beste tilpasning med y = B + C cos(x) + D sin(x) + E cos(2x) + F sin(2x) + G cos(3x) + H sin(3x)
pts = [ [-4,-1], [-3,0], [-2,-1.5], [-1,0.5], [0, 1], [1, 0.5], [2,1], [3,1], [4,1]]

# Her kan du endre hva du tar regresjon med henhold på!!!

#vect = lambda x: vector([exp(sin(x)), exp(cos(x)), sin(x), cos(x), exp(tan(x))])
vect = lambda x: vector([x^2, sin(x), cos(x), sin(2*x), cos(2*x), x^3, x^4, sin(3*x), cos(3*x)])
#vect = lambda x: vector([1,x])
#vect = lambda x: vector([1, x, x^2, x^3, x^4, x^5, sin(x), cos(x)])


# Annet eksempel:
#vect = lambda x: vector([1, x^2, sin(x)])

A = Matrix( list( vect(k) for k in list(k[0] for k in pts)))
z = vector(list(k[1] for k in pts))

# Én måte å beregne koeffisientene: Moore-Penrose psevdoinversen
coeffs = N(A).pseudoinverse() * z
# Én annen måte: Normallikningen
#coeffs = (N(transpose(A)) * N(A))^(-1) * N(transpose(A)) * z


f(x) = N(coeffs) * vect(x)
print(f(x)) # Funksjonen

i = list_plot(pts, color="red") + plot(f(x),x,-5,5, ymax=5, ymin=-5)
NAME="minste_kvadraters.png"
print(f"Plot saved to {NAME}.")
i.save(NAME, dpi=500)
